#!/usr/local/bin/php -q
<?php
	# Mantis - a php based bugtracking system
	# Copyright (C) 2000 - 2002  Kenzaburo Ito - kenito@300baud.org
	# Copyright (C) 2002 - 2004  Mantis Team   - mantisbt-dev@lists.sourceforge.net
	# Copyright (C) 2005         Koji Shino    - hiro@shino.ac
	# This program is distributed under the terms and conditions of the GPL
	# See the README and LICENSE files for details


	global $g_bypass_headers;
	$g_bypass_headers = 1;
	require_once( dirname( dirname( __FILE__ ) ) . DIRECTORY_SEPARATOR . 'core.php' );

	# Check Argument Count
	if ($argc != 3) {
		echo "usage: checkin_svn.php <repository-path> <revision-No>\n";
		exit( 1 );
	}

	# Get Commit Information and Log Message
	$t_commitInfo = `svnlook info $argv[1] -r $argv[2]`;

	# Convert Encoding if you need.
	$t_commitInfo = mb_convert_encoding($t_commitInfo, 'EUC-JP', 'Shift_JIS' );

	# Parse Commit Information
	list($t_username, $t_commitDate, $t_logLen, $t_comment) = explode("\n",$t_commitInfo, 4);
	$t_username = trim($t_username);

	if ( is_blank( $t_username ) || ( user_get_id_by_name( $t_username ) === false ) ) {
		echo "Invalid source control account ('$t_username').\n";
		exit( 1 );
	}

	# Detect references to issues + concat all lines to have the comment log.
	$t_commit_regexp = config_get( 'source_control_regexp' );

	$t_issues = array();
	if ( preg_match_all( $t_commit_regexp, $t_comment, $t_matches ) ) {
		for ( $i = 0; $i < count( $t_matches[0] ); ++$i ) {
			$t_issues[] = $t_matches[1][$i];
		}
	}

	# Add Navigation from Mantis Item To SubVersion Revisiion.
	# If you don't need this, Comment out below Line.
	$t_comment = $t_comment . "\n svn:$argv[2]";

	# If no issues found, then no work to do.
	if ( count( $t_issues ) == 0 ) {
		echo "Comment does not reference any issues.\n";
		exit(0);
	}

	# Login as source control user
	if ( !auth_attempt_script_login( $t_username ) ) {
		echo "Unable to login\n";
		exit( 1 );
	}

	# history parameters are reserved for future use.
	$t_history_old_value = '';
	$t_history_new_value = '';

	# Call the custom function to register the checkin on each issue.
	foreach ( $t_issues as $t_issue_id ) { 
		helper_call_custom_function( 'checkin', array( $t_issue_id, $t_comment, $t_history_old_value, $t_history_new_value ) );
	}

	exit( 0 );
?>